import { GCOptimizedList } from "encompass-gc-optimized-collections";
import { Component } from "./component";
import { DrawLayerManager } from "./draw_layer_manager";
import { ComponentUserDataOnly } from "./interfaces/component_user_data_only";
import { IDrawable } from "./interfaces/drawable";
import { Type } from "./types/generic_type";
export declare class ComponentManager {
    private component_type_to_active_components_map;
    private component_type_to_inactive_components_map;
    private components_to_activate;
    private components_to_deactivate;
    private components_to_remove;
    create_component<TComponent extends Component>(ComponentType: Type<TComponent>, entity_id: number, draw_layer_manager: DrawLayerManager<IDrawable>, properties?: ComponentUserDataOnly<TComponent>): TComponent;
    get_components_by_component_type<TComponent extends Component>(ComponentType: Type<TComponent>): GCOptimizedList<Readonly<TComponent>>;
    get_inactive_components_by_component_type<TComponent extends Component>(ComponentType: Type<TComponent>): GCOptimizedList<Readonly<TComponent>>;
    activate_components(): void;
    deactivate_components(): void;
    remove_components(): void;
    mark_for_activation(component: Component): void;
    mark_for_deactivation(component: Component): void;
    mark_for_removal(component: Component): void;
    protected perform_remove_component(component: Component): void;
    protected perform_deactivate_component(component: Component): void;
    protected perform_activate_component(component: Component): void;
}
