"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const component_1 = require("./component");
class DrawComponent extends component_1.Component {
    get layer() { return this._layer; }
    set layer(num) {
        if (num === this._layer) {
            return;
        }
        this.draw_layer_manager.adjust_object_layer(this, this._layer, num);
        this._layer = num;
    }
    constructor(DrawComponentType, entity_id, layer_manager) {
        super(DrawComponentType, entity_id);
        this._layer = 0;
        this.draw_layer_manager = layer_manager;
        this.draw_layer_manager.register_object_with_layer(this, this._layer);
    }
    activate() {
        this.draw_layer_manager.register_object_with_layer(this, this._layer);
        super.activate();
    }
    deactivate() {
        this.draw_layer_manager.unregister_object_with_layer(this, this._layer);
        super.deactivate();
    }
    destroy() {
        this.draw_layer_manager.unregister_object_with_layer(this, this._layer);
        super.destroy();
    }
}
exports.DrawComponent = DrawComponent;
