import { GCOptimizedMap, GCOptimizedSet, GCOptimizedSortedList } from "encompass-gc-optimized-collections";
export declare class DrawLayerManager<T> {
    private _draw_order;
    private layer_index_to_component_set;
    private order;
    readonly draw_order: T[];
    constructor(layer_index_to_component_set: GCOptimizedMap<number, GCOptimizedSet<T>>, order: GCOptimizedSortedList<number>);
    register_object_with_layer(object: T, layer: number): void;
    unregister_object_with_layer(object: T, layer: number): void;
    adjust_object_layer(object: T, old_layer: number, new_layer: number): void;
    insert(draw_component: T, layer: number): void;
}
