"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const encompass_gc_optimized_collections_1 = require("encompass-gc-optimized-collections");
class DrawLayerManager {
    constructor(layer_index_to_component_set, order) {
        this._draw_order = [];
        this.layer_index_to_component_set = layer_index_to_component_set;
        this.order = order;
    }
    get draw_order() { return this._draw_order; }
    register_object_with_layer(object, layer) {
        this.insert(object, layer);
    }
    unregister_object_with_layer(object, layer) {
        if (this.layer_index_to_component_set.has(layer)) {
            this.layer_index_to_component_set.get(layer).delete(object);
        }
    }
    adjust_object_layer(object, old_layer, new_layer) {
        this.unregister_object_with_layer(object, old_layer);
        this.register_object_with_layer(object, new_layer);
    }
    insert(draw_component, layer) {
        if (this.layer_index_to_component_set.has(layer)) {
            const set = this.layer_index_to_component_set.get(layer);
            set.add(draw_component);
        }
        else {
            const set = new encompass_gc_optimized_collections_1.GCOptimizedSet();
            this.layer_index_to_component_set.set(layer, set);
            set.add(draw_component);
            this.order.add(layer);
        }
    }
}
exports.DrawLayerManager = DrawLayerManager;
