"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const engine_1 = require("../engine");
/**
 * A Spawner is a special subtype of Engine which is intended
 * to read one single type of Message and create a new Entity
 * in response.
 */
class Spawner extends engine_1.Engine {
    update() {
        const messages = this.read_messages(this.read_message_types.get(0));
        for (const message of messages.values()) {
            this.spawn(message);
        }
    }
}
exports.Spawner = Spawner;
