"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const entity_1 = require("./entity");
class EntityCreator {
    constructor(entities, id_to_entity, entities_with_added_components, entities_with_removed_components, entities_marked_for_destroy, component_manager, draw_layer_manager) {
        this.next_id_value = 1;
        this.entities = entities;
        this.id_to_entity = id_to_entity;
        this.entities_with_added_components = entities_with_added_components;
        this.entities_with_removed_components = entities_with_removed_components;
        this.entities_marked_for_destroy = entities_marked_for_destroy;
        this.component_manager = component_manager;
        this.draw_layer_manager = draw_layer_manager;
    }
    create_entity() {
        const id = this.next_id();
        const entity = new entity_1.Entity(id, this.entities_with_added_components, this.entities_with_removed_components, this.entities_marked_for_destroy, this.draw_layer_manager, this.component_manager);
        this.entities.add(entity);
        this.id_to_entity.set(id, entity);
        return entity;
    }
    next_id() {
        const value = this.next_id_value;
        this.next_id_value += 1;
        return value;
    }
}
exports.EntityCreator = EntityCreator;
