"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class EngineMutationConflictError {
    constructor(duplicate_mutations, component_to_engines_map) {
        this.duplicate_mutations = duplicate_mutations;
        this.component_to_engines_map = component_to_engines_map;
    }
    toString() {
        let string = "Multiple engines mutate the same component:";
        for (const component_type of this.duplicate_mutations) {
            string += "\n" +
                component_type.name + " mutated by: ";
            const engines = this.component_to_engines_map.get(component_type);
            string += engines.map((engine) => engine.constructor.name).join(", ");
        }
        return string;
    }
}
exports.EngineMutationConflictError = EngineMutationConflictError;
