"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Graph {
    constructor() {
        this._vertices = [];
        this._edges = new Map();
    }
    get vertices() {
        return this._vertices;
    }
    neighbors(vertex) {
        if (this.vertex_exists(vertex)) {
            return [...this._edges.get(vertex)];
        }
        else {
            return [];
        }
    }
    add_vertex(vertex) {
        if (!this.vertex_exists(vertex)) {
            this._vertices.push(vertex);
            this._edges.set(vertex, []);
        }
    }
    add_vertices(...vertices) {
        for (const vertex of vertices) {
            this.add_vertex(vertex);
        }
    }
    vertex_exists(vertex) {
        return this.vertices.indexOf(vertex) !== -1;
    }
    remove_vertex(v) {
        if (this.vertex_exists(v)) {
            for (const u of this.neighbors(v)) {
                this.remove_edge([v, u]);
            }
            this.vertices.splice(this.vertices.indexOf(v), 1);
        }
    }
}
exports.Graph = Graph;
