"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const encompass_gc_optimized_collections_1 = require("encompass-gc-optimized-collections");
class MessageQuery {
    constructor() {
        this.message_query_set = new encompass_gc_optimized_collections_1.GCOptimizedSet();
    }
    init(message_set) {
        this.message_query_set.clear();
        for (const message of message_set.entries()) {
            this.message_query_set.add(message);
        }
        return this;
    }
    filter_by_entity_id(entity_id) {
        for (const message of this.message_query_set.entries()) {
            if (this.isEntityMessage(message)) {
                if (message.entity.id !== entity_id) {
                    this.message_query_set.delete(message);
                }
            }
            else {
                this.message_query_set.delete(message);
            }
        }
        return this;
    }
    finish() {
        return this.message_query_set;
    }
    isEntityMessage(message) {
        return message.entity !== undefined;
    }
}
exports.MessageQuery = MessageQuery;
