import { GCOptimizedList, GCOptimizedMap } from "encompass-gc-optimized-collections";
import { ComponentManager } from "./component_manager";
import { DrawLayerManager } from "./draw_layer_manager";
import { Entity } from "./entity";
import { IDrawable } from "./interfaces/drawable";
export declare class EntityCreator {
    private entities;
    private entities_with_added_components;
    private entities_with_removed_components;
    private entities_marked_for_destroy;
    private next_id_value;
    private id_to_entity;
    private component_manager;
    private draw_layer_manager;
    constructor(entities: GCOptimizedList<Entity>, id_to_entity: GCOptimizedMap<number, Entity>, entities_with_added_components: GCOptimizedList<Entity>, entities_with_removed_components: GCOptimizedList<Entity>, entities_marked_for_destroy: GCOptimizedList<Entity>, component_manager: ComponentManager, draw_layer_manager: DrawLayerManager<IDrawable>);
    create_entity(): Entity;
    private next_id;
}
