import { GCOptimizedList, GCOptimizedMap } from "encompass-gc-optimized-collections";
import { Entity } from "./entity";
import { IDrawableEntityTracker } from "./interfaces/drawable_entity_tracker";
import { IEntityTracker } from "./interfaces/entity_tracker";
export declare class EntityManager {
    private entities_with_added_components;
    private entities_with_removed_components;
    private entities_marked_for_destroy;
    private entities;
    private id_to_entity;
    private entity_to_entity_trackers_map;
    private component_type_to_entity_trackers_map;
    constructor(entities: GCOptimizedList<Entity>, id_to_entity: GCOptimizedMap<number, Entity>, entities_with_added_components: GCOptimizedList<Entity>, entities_with_removed_components: GCOptimizedList<Entity>, entities_marked_for_destroy: GCOptimizedList<Entity>);
    check_entities_with_added_components(): void;
    check_entities_with_removed_components(): void;
    register_entity_tracker(entity_tracker: IEntityTracker): void;
    register_drawable_entity_tracker(drawable_entity_tracker: IDrawableEntityTracker): void;
    destroy_marked_entities(): void;
    get_entity(id: number): Entity | undefined;
    private is_entity_tracker;
    private get_or_create_entity_tracker_set;
    private check_and_register_entity;
}
