--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 8,["10"] = 8,["11"] = 8,["12"] = 8,["13"] = 8,["14"] = 8,["15"] = 8,["21"] = 20,["22"] = 16,["23"] = 17,["24"] = 26,["25"] = 27,["26"] = 28,["27"] = 29,["28"] = 30,["30"] = 33,["31"] = 34,["32"] = 35,["34"] = 37,["36"] = 40,["37"] = 41,["38"] = 42,["39"] = 43,["40"] = 44,["41"] = 45,["46"] = 50,["48"] = 53,["49"] = 54,["50"] = 55,["51"] = 56,["54"] = 60,["55"] = 61,["56"] = 62,["57"] = 63,["59"] = 66,["60"] = 67,["61"] = 68,["62"] = 70,["63"] = 71,["64"] = 72,["67"] = 76,["68"] = 78,["69"] = 79,["71"] = 82,["73"] = 85,["74"] = 86,["76"] = 89,["77"] = 90,["79"] = 94,["80"] = 95,["81"] = 96,["83"] = 98,["85"] = 101,["86"] = 102,["87"] = 103,["88"] = 104,["89"] = 105,["90"] = 106,["91"] = 107,["93"] = 109});
local ____exports = {}
local __TSTL_encompass_2Dgc_2Doptimized_2Dcollections = require("encompass-gc-optimized-collections")
local GCOptimizedList = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedList
local GCOptimizedMap = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedMap
local GCOptimizedSet = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedSet
____exports.EntityManager = {}
local EntityManager = ____exports.EntityManager
EntityManager.name = "EntityManager"
EntityManager.__index = EntityManager
EntityManager.prototype = {}
EntityManager.prototype.__index = EntityManager.prototype
EntityManager.prototype.constructor = EntityManager
function EntityManager.new(...)
    local self = setmetatable({}, EntityManager.prototype)
    self:____constructor(...)
    return self
end
function EntityManager.prototype.____constructor(self, entities, id_to_entity, entities_with_added_components, entities_with_removed_components, entities_marked_for_destroy)
    self.entity_to_entity_trackers_map = GCOptimizedMap.new()
    self.component_type_to_entity_trackers_map = GCOptimizedMap.new()
    self.entities = entities
    self.id_to_entity = id_to_entity
    self.entities_with_added_components = entities_with_added_components
    self.entities_with_removed_components = entities_with_removed_components
    self.entities_marked_for_destroy = entities_marked_for_destroy
end
function EntityManager.prototype.check_entities_with_added_components(self)
    for entity in self.entities_with_added_components:values() do
        self:check_and_register_entity(entity)
    end
    self.entities_with_added_components:clear()
end
function EntityManager.prototype.check_entities_with_removed_components(self)
    for entity in self.entities_with_removed_components:values() do
        if self.entity_to_entity_trackers_map:has(entity) then
            for engine in self.entity_to_entity_trackers_map:get(entity):entries() do
                if self:is_entity_tracker(engine) then
                    engine:check_and_untrack_entity(entity.id)
                end
            end
        end
    end
    self.entities_with_removed_components:clear()
end
function EntityManager.prototype.register_entity_tracker(self, entity_tracker)
    for ____, component_type in ipairs(entity_tracker.component_types) do
        local entity_tracker_set = self:get_or_create_entity_tracker_set(component_type)
        entity_tracker_set:add(entity_tracker)
    end
end
function EntityManager.prototype.register_drawable_entity_tracker(self, drawable_entity_tracker)
    self:register_entity_tracker(drawable_entity_tracker)
    local entity_tracker_set = self:get_or_create_entity_tracker_set(drawable_entity_tracker.draw_component_type)
    entity_tracker_set:add(drawable_entity_tracker)
end
function EntityManager.prototype.destroy_marked_entities(self)
    for entity in self.entities_marked_for_destroy:values() do
        entity:remove_all_components()
        if self.entity_to_entity_trackers_map:has(entity) then
            for tracker in self.entity_to_entity_trackers_map:get(entity):entries() do
                tracker:check_and_untrack_entity(entity.id)
            end
        end
        self.entity_to_entity_trackers_map:delete(entity)
        self.entities:deleteValue(entity)
        self.id_to_entity:delete(entity.id)
    end
    self.entities_marked_for_destroy:clear()
end
function EntityManager.prototype.get_entity(self, id)
    return self.id_to_entity:get(id)
end
function EntityManager.prototype.is_entity_tracker(self, engine)
    return engine.check_and_untrack_entity ~= nil
end
function EntityManager.prototype.get_or_create_entity_tracker_set(self, component_type)
    if not self.component_type_to_entity_trackers_map:has(component_type) then
        self.component_type_to_entity_trackers_map:set(component_type, GCOptimizedList.new())
    end
    return self.component_type_to_entity_trackers_map:get(component_type)
end
function EntityManager.prototype.check_and_register_entity(self, entity)
    for component_type in entity.component_types:entries() do
        if self.component_type_to_entity_trackers_map:has(component_type) then
            for entity_tracker in self.component_type_to_entity_trackers_map:get(component_type):values() do
                if entity_tracker:check_and_track_entity(entity.id) then
                    if not self.entity_to_entity_trackers_map:has(entity) then
                        self.entity_to_entity_trackers_map:set(entity, GCOptimizedSet.new())
                    end
                    self.entity_to_entity_trackers_map:get(entity):add(entity_tracker)
                end
            end
        end
    end
end
return ____exports
