import { Graph } from "./graph";
declare enum SearchSymbol {
    start = 0,
    finish = 1
}
export declare class DirectedGraph<T> extends Graph<T> {
    add_edge(u: T, v: T): void;
    add_edges(...edges: [T, T][]): void;
    node_dfs(): Map<T, Map<SearchSymbol, number>>;
    topological_sort(): T[];
    clone(): DirectedGraph<T>;
    cyclic(): boolean;
    acyclic(): boolean;
    /**
     * Uses Tarjan's algorithm with Nuutila's modifications. Nonrecursive.
     */
    strongly_connected_components(): T[][];
    /**
     * Uses Johnson's cycle finding algorithm.
     */
    simple_cycles(): T[][];
    subgraph(vertices: T[]): DirectedGraph<T>;
    remove_edge(edge: [T, T]): void;
}
export {};
