export declare abstract class Graph<T> {
    protected _vertices: T[];
    protected _edges: Map<T, T[]>;
    readonly vertices: T[];
    neighbors(vertex: T): T[];
    add_vertex(vertex: T): void;
    add_vertices(...vertices: T[]): void;
    vertex_exists(vertex: T): boolean;
    remove_vertex(v: T): void;
    abstract remove_edge(edge: [T, T]): void;
}
