import { GCOptimizedList } from "encompass-gc-optimized-collections";
import { Component } from "./component";
import { Entity } from "./entity";
import { Message } from "./message";
import { MessageQuery } from "./message_query";
import { ComponentMessage } from "./types/component_message";
import { EntityMessage } from "./types/entity_message";
import { Type } from "./types/generic_type";
export declare class MessageManager {
    message_query: MessageQuery;
    private messages;
    private message_pools;
    private message_type_to_messages_map;
    create_component_message<TComponentMessage extends ComponentMessage>(ComponentMessageType: Type<TComponentMessage>, component: Component): TComponentMessage;
    create_entity_message<TEntityMessage extends EntityMessage>(EntityMessageType: Type<TEntityMessage>, entity: Entity): TEntityMessage;
    create_message<TMessage extends Message>(MessageType: Type<TMessage>): TMessage;
    clear_messages(): void;
    get_messages_by_message_type<TMessage extends Message>(MessageType: Type<TMessage>): GCOptimizedList<TMessage>;
    private cache_message_by_message_type;
    private create_or_get_message_pool;
}
