import { GCOptimizedList } from "encompass-gc-optimized-collections";
import { Type } from "./types/generic_type";
export declare class ObjectPool<T> {
    readonly size: number;
    readonly inactive_objects: GCOptimizedList<T>;
    readonly active_objects: GCOptimizedList<T>;
    static OverflowBehaviorFallible: () => null;
    static OverflowBehaviorCycle: <T_1>(pool: ObjectPool<T_1>) => NonNullable<T_1>;
    static OverflowBehaviorExpand: <T_1>(pool: ObjectPool<T_1>) => NonNullable<T_1>;
    static DefaultDestructor: <T_1>(object: T_1) => void;
    overflow_behavior: (pool: ObjectPool<T>) => T | null;
    private _size;
    private _inactive_objects;
    private _active_objects;
    private constructor_function;
    private destructor_function;
    private reference_object;
    constructor(object_constructor: new (constructor: Type<T>) => T, object_destructor?: (destructor: T) => void, size?: number, overflow_behavior?: (pool: ObjectPool<T>) => T | null);
    obtain(): T | null;
    free(instance: T): void;
    free_all(): void;
    private generate;
    private get_inactive_object;
}
