import { Engine } from "../engine";
import { Message } from "../message";

/**
 * A Spawner is a special subtype of Engine which is intended
 * to read one single type of Message and create a new Entity
 * in response.
 */
export abstract class Spawner extends Engine {
    public update() {
        const messages = this.read_messages(this.read_message_types.get(0)!);
        for (const message of messages.values()) {
            this.spawn(message);
        }
    }

    protected abstract spawn(message: Message): void;
}
